ru.bitel.bgbilling.modules.megogo.server.event

## Class MegogoSubscriptionUpdateEvent

- java.lang.Object
- - ru.bitel.bgbilling.kernel.event.Event
  - - ru.bitel.bgbilling.kernel.event.QueueEvent
    - - ru.bitel.bgbilling.kernel.event.LocalEvent
      - - ru.bitel.bgbilling.modules.megogo.server.event.MegogoSubscriptionUpdateEvent

- All Implemented Interfaces:
    java.io.Serializable, ErrorReturnableEvent

      public class MegogoSubscriptionUpdateEvent
      extends LocalEvent
      implements ErrorReturnableEvent

  Синхронное событие, которое бросается перед созданием/изменением подписки(и возможно непосредственно запросом Megogo). Которое можно обработать самому.
  Если скрипт-обработки выставляет флаг processed=true, то тогда штатная логика не срабатывает. Если поле errorMessage будет не пустым, провоцируется ошибка с данным сообщением.
  See Also:
    Serialized Form

- - ### Field Summary

    - ### Fields inherited from class ru.bitel.bgbilling.kernel.event.Event

      `CONTRACT_GLOBAL, NO_MODULE, NO_PLUGIN`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `MegogoSubscriptionUpdateEvent(int moduleId, MegogoContractSubscription contractSubscription, int userId, boolean sendToMegogo)`
    `MegogoSubscriptionUpdateEvent(int moduleId, MegogoContractSubscription contractSubscription, int userId, boolean sendToMegogo, MegogoSubscription subscriptionTo)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `MegogoContractSubscription` | `getContractSubscription()`
    `java.lang.String` | `getError()`
    `MegogoSubscription` | `getSubscriptionTo()` Если это переход(то есть основной тип), то подписка на которую планируем перейти после завершения этой
    `boolean` | `isCreate()`
    `boolean` | `isProcessed()`
    `boolean` | `isSendToMegogo()`
    `void` | `setContractSubscription(MegogoContractSubscription contractSubscription)`
    `void` | `setErrorMessage(java.lang.String errorMessage)`
    `void` | `setProcessed(boolean processed)`
    `void` | `setSubscriptionTo(MegogoSubscription subscriptionTo)`

    - ### Methods inherited from class ru.bitel.bgbilling.kernel.event.Event

      `getContractId, getContractID, getDestination, getGenerateTime, getModuleId, getModuleID, getPluginId, getSuperContractId, getTime, getTimestamp, getTypeId, getUserId, isLogFunctionProcess, prepareMessage, serializeAsObject, setLogFunctionProcess, toString, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### MegogoSubscriptionUpdateEvent

          public MegogoSubscriptionUpdateEvent(int moduleId,
                                               MegogoContractSubscription contractSubscription,
                                               int userId,
                                               boolean sendToMegogo)

    - #### MegogoSubscriptionUpdateEvent

          public MegogoSubscriptionUpdateEvent(int moduleId,
                                               MegogoContractSubscription contractSubscription,
                                               int userId,
                                               boolean sendToMegogo,
                                               MegogoSubscription subscriptionTo)

  - ### Method Detail

    - #### isCreate

          public boolean isCreate()

      Returns:
        - true, если создание, false - если изменение подписки.

    - #### isProcessed

          public boolean isProcessed()

    - #### setProcessed

          public void setProcessed(boolean processed)

    - #### setErrorMessage

          public void setErrorMessage(java.lang.String errorMessage)

    - #### getContractSubscription

          public MegogoContractSubscription getContractSubscription()

    - #### setContractSubscription

          public void setContractSubscription(MegogoContractSubscription contractSubscription)

    - #### isSendToMegogo

          public boolean isSendToMegogo()

      Returns:
        - false, то запрос к Megogo прямо сейчас отправляться не будет( при этом не дает гарантии, что этого не сделает планировщик позже )

    - #### getSubscriptionTo

          public MegogoSubscription getSubscriptionTo()

      Если это переход(то есть основной тип), то подписка на которую планируем перейти после завершения этой

    - #### setSubscriptionTo

          public void setSubscriptionTo(MegogoSubscription subscriptionTo)

    - #### getError

          public java.lang.String getError()

      Specified by:
        `getError` in interface `ErrorReturnableEvent`